# -*- coding: utf-8 -*-
from setuphelpers import *
import time

# Declaring specific app values (TO CHANGE)
app_name = "Tixeo Communication Client"
bin_zip_string = "TixeoClient_%s.zip"
processes_to_kill = "W3DClient"
app_sys_dir_publisher = makepath(programfiles32, "Tixeo Soft")
app_sys_dir_short = makepath(programfiles32, "Tixeo Soft", "Communication")
app_sys_dir = makepath(app_sys_dir_short, "Client")
app_sys_dir_temp = makepath(app_sys_dir_short, "TixeoClient")
app_sys_path = makepath(app_sys_dir, "W3DClient.exe")


def install():
    # Specific app values
    package_version = control.version.split("-")[0]

    # Installing the package
    if isdir(app_sys_dir):
        remove_tree(app_sys_dir)
        mkdirs(app_sys_dir_short)
    unzip(bin_zip_string % package_version, target=app_sys_dir_short)
    os.rename(app_sys_dir_temp, app_sys_dir)

    create_programs_menu_shortcut(app_name, app_sys_path)


def uninstall():
    # Uninstalling the package
    killalltasks(processes_to_kill)
    remove_tree(app_sys_dir)
    if dir_is_empty(app_sys_dir_short):
        remove_tree(app_sys_dir_short)
    if dir_is_empty(app_sys_dir_publisher):
        remove_tree(app_sys_dir_publisher)
    remove_programs_menu_shortcut(app_name)


def session_setup():
    # Specific app values
    app_user_dir = makepath(user_local_appdata, "Tixeo Soft", "Communication", "Client")
    app_user_dir_publisher = makepath(user_local_appdata, "Tixeo Soft")
    app_user_dir_short = makepath(user_local_appdata, "Tixeo Soft", "Communication")
    app_user_updater = makepath(app_user_dir, "upd.exe")
    app_user_uninstaller = makepath(app_user_dir, "unins001.exe")
    app_user_uninstall_cmd = '"%s" %s' % (app_user_uninstaller, " /silent")

    if isdir(app_user_dir_publisher):
        try:
            killalltasks(processes_to_kill)
            print("Running: " + app_user_uninstall_cmd)
            run(app_user_uninstall_cmd)
        except:
            print("The uninstallation in user environnement probably passed even with errors")

        time.sleep(10)
        remove_tree(app_user_dir)
        if dir_is_empty(app_user_dir_short):
            remove_tree(app_user_dir_short)
        if dir_is_empty(app_user_dir_publisher):
            remove_tree(app_user_dir_publisher)
        remove_user_programs_menu_shortcut(app_name)
        remove_user_desktop_shortcut(app_name)

    if reg_value_exists(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "W3DClient"):
        print("Disabling: Run at Startup")
        registry_delete(HKEY_CURRENT_USER, r"SOFTWARE\Microsoft\Windows\CurrentVersion\Run", "W3DClient")
